/*******************************************************************************
! global.h
! 
! contains global parameter
*******************************************************************************/

#ifndef _GLOBAL_H
#define _GLOBAL_H

#if defined _MAIN_PROGRAM
  #define EXTERN
#else
  #define EXTERN extern
#endif

#include "su3.h"
#ifdef MPI
  #include <mpi.h>
#endif

#if defined PARALLEL1
   #define N_PROC_X 8
   #define N_PROC_Y 1
   #define N_PROC_Z 1
#elif defined PARALLEL2
   #define N_PROC_X 4
   #define N_PROC_Y 2
   #define N_PROC_Z 1
#elif defined PARALLEL3
   #define N_PROC_X 4
   #define N_PROC_Y 2
   #define N_PROC_Z 2
#else
   #define N_PROC_X 1
   #define N_PROC_Y 1
   #define N_PROC_Z 1
#endif

#if ((defined SSE)||(defined SSE2))
  #if defined P4
    #define ALIGN_BASE 0x3f
    #define ALIGN __attribute__ ((aligned (64)))
  #else 
    #define ALIGN_BASE 0x1f
    #define ALIGN __attribute__ ((aligned (32)))
  #endif
#else
  #define ALIGN_BASE 0xf 
  #define ALIGN
#endif

EXTERN int T, L;
EXTERN int **** g_ipt;
EXTERN int **   g_iup;
EXTERN int **   g_idn;
EXTERN su3 **   g_gauge_field;

EXTERN double g_mu;
EXTERN double g_beta;
EXTERN double g_kappa;

/***** CRATE constants *********************************/
EXTERN int CRATE_N_PROCX, CRATE_N_PROCY, CRATE_N_PROCZ;
/*******************************************************/

#define LX       L
#define LY       L
#define LZ       L
#define VOLUME   (T*LX*LY*LZ)
#define DIM      4
#define NCOL     3

#if defined PARALLEL1
#define RAND (2*T*LY*LZ)
#define VOLUMEPLUSRAND (T*(LX+2)*LY*LZ)
#elif defined PARALLEL2
#define RAND (2*T*(LY*LZ+LX*LZ))
#define VOLUMEPLUSRAND (T*(LX+2)*(LY+2)*LZ)
#elif defined PARALLEL3
#define RAND (2*T*(LY*LZ+LX*LZ+LX*LY))
#define VOLUMEPLUSRAND (T*(LX+2)*(LY+2)*(LZ+2))
#else
#define RAND 0
/* #define VOLUMEPLUSRAND (T*LX*LY*LZ) */
#define VOLUMEPLUSRAND VOLUME
#endif

#undef EXTERN

#endif
