/* $Id: gmres_sse.h,v 1.2 2003/03/27 12:01:58 urbach Exp $ */
#ifndef _GMRES_SSE_H
#define _GMRES_SSE_H
#ifdef SSE2

#include "sse-extension/sse.h"

#define _gmres_giv_rotation1(a,b,c) \
	__asm__ __volatile__ ("movapd %0, %%xmm0 \n\t" \
			      "movapd %1, %%xmm6 \n\t" \
			      "movapd %2, %%xmm7 \n\t" \
			      "movapd %%xmm0, %%xmm5 \n\t" \
			      "mulpd %%xmm6, %%xmm5 \n\t" \
			      "mulpd %%xmm7, %%xmm0 \n\t" \
			      : \
			      : \
			      "m" (a), \
			      "m" (b), \
			      "m" (c))

#define _gmres_giv_rotation2(a,b) \
	__asm__ __volatile__ ("movsd %1, %%xmm1 \n\t" \
			      "movsd %2, %%xmm2 \n\t" \
			      "unpcklpd %%xmm1, %%xmm1 \n\t" \
			      "unpcklpd %%xmm2, %%xmm2 \n\t" \
			      "movapd %%xmm6, %%xmm3 \n\t" \
			      "mulpd %%xmm1, %%xmm6 \n\t" \
			      "mulpd %%xmm2, %%xmm3 \n\t" \
			      "shufpd $0x1, %%xmm3, %%xmm3 \n\t" \
			      "xorpd %3, %%xmm3 \n\t" \
			      "subpd %%xmm3, %%xmm6 \n\t" \
			      "addpd %%xmm6, %%xmm0 \n\t" \
			      "movapd %%xmm0, %0 \n\t" \
			      : \
                              "=m" (b) \
			      : \
			      "m" ((a).re), \
			      "m" ((a).im), \
			      "m" (_sse_sgn))

#define _gmres_giv_rotation3(a) \
	__asm__ __volatile__ ("movapd %%xmm7, %%xmm3 \n\t" \
			      "mulpd %%xmm1, %%xmm7 \n\t" \
			      "mulpd %%xmm2, %%xmm3 \n\t" \
			      "shufpd $0x1, %%xmm3, %%xmm3 \n\t" \
			      "xorpd %1, %%xmm3 \n\t" \
			      "addpd %%xmm3, %%xmm7 \n\t" \
			      "subpd %%xmm7, %%xmm5 \n\t" \
			      "movapd %%xmm5, %0 \n\t" \
			      : \
                              "=m" (a) \
			      : \
			      "m" (_sse_sgn))


#endif /* SSE2 */
#endif /* Header */
